#ifndef CDO_BENCHMARK_H
#define CDO_BENCHMARK_H
#define DBE2
#ifdef DBE2

#include <iostream>
#include <chrono>

template <typename func>
void
cdo_benchmark(func lambda)
{
  auto start = std::chrono::steady_clock::now();
  lambda();
  auto end = std::chrono::steady_clock::now();
  auto elapsedm = std::chrono::duration_cast<std::chrono::nanoseconds>(end - start).count();
  // time end
  std::cout << "time: " << elapsedm << " ns" << std::endl;
}

#define CDO_BENCH(x) cdo_benchmark(x)

#else
#define CDO_BENCH(x)                                                                            \
  std::cout << "benchmark found, please remove. " << __FILE__ << ": " << __LINE__ << std::endl; \
  x()
#endif
#endif
